#ce script permet de récupérer le texte brut depuis l API de gallica



######fonction recup_txt
recup_txt=function(num_tome){
  
  tome_url <- recup_url_txt(num_tome)
  tome_html<- read_html(tome_url)
  
  # création de allbodynodes allnodes allhr et allspan
  allbodynodes <- tome_html %>%    xml_node('body')
  allnodes <- allbodynodes %>%  xml_nodes('*')
  allhr    <- allbodynodes %>%  xml_nodes('hr')
  allspan  <- allbodynodes %>%  xml_nodes('p *')
  
  # extraction du texte
  alltext <- allnodes %>%
    html_text(trim = T) %>%      
    as.data.frame(stringsAsFactors = F) %>% 
    select(texte = '.') %>% 
    
    mutate(
     isspan = allnodes %in% allspan, # detection span
     ishr = allnodes %in% allhr,     # detection hr (horizontal row)
     page = cumsum(ishr),            # calcul du numero de page
     num_tome=num_tome) %>%  

    filter(!ishr) %>%   # suppression des lignes hr
    select(-ishr) %>%   
    filter(!isspan) %>% # suppression lignes span
    select(-isspan) %>% 
     
    mutate(
     v1 = 1 ,
     nb_parap  = ave(v1, page, FUN = sum),       #nb de paragraphes dans la page
     num_parap = ave(v1, page, FUN = seq_along), #numero du paragraphe dans la page
     num_page=page-page_deb[num_tome]+1
     ) %>%
    filter(page>=page_deb[num_tome] & page<= page_fin[num_tome]) %>%
    select(-page, -v1)

  return(alltext)
}


df8_txt <- recup_txt(8)
df9_txt <- recup_txt(9)
df10_txt <- recup_txt(10)
df11_txt <- recup_txt(11)
df12_txt <- recup_txt(12)








