#ce script contient les fonctions utilisees dans le script8


############################################################################
# fonction meta1_espaces_et_fautes_de_frappe
#
# cette fonction corrige les fautes de frappe 
###########################################################################


#################################################################
meta1_espaces_et_fautes_de_frappe = function(df_txt_sty_nbp_chr_dep_tdm) {
  
  df_txt_sty_nbp_chr_dep_tdm_met1 <- df_txt_sty_nbp_chr_dep_tdm %>%
    mutate ( 
      #remplacement de certains caracteres par des espaces
      meta_dep=str_replace_all(meta_dep,"\\?"," "),
      meta_dep=str_replace_all(meta_dep,"\\'"," "),
      meta_dep=str_replace_all(meta_dep,"\\-"," "),
      meta_dep=str_replace_all(meta_dep,"\\°"," "),
      
      #corrections des erreurs de frappe
      meta_dep=str_replace_all(meta_dep, "ambassadeur", "Ambassadeur"),
      meta_dep=str_replace_all(meta_dep, "la Tour", "La Tour"),
      meta_dep=str_replace_all(meta_dep, ", Drouyn de Lhuys", ", à Drouyn de Lhuys"),
      meta_dep=str_replace_all(meta_dep, "à Drouyn de de Lhuys", "à Drouyn de Lhuys"),
      meta_dep=str_replace_all(meta_dep, "Drouyn 94", "Drouyn de"),
      meta_dep=str_replace_all(meta_dep, "à Drouyn de Lhnys", "à Drouyn de Lhuys"),
      meta_dep=str_replace_all(meta_dep, "Charge d Affaires", "Chargé d Affaires"),
      meta_dep=str_replace_all(meta_dep, "Ambassadeur à Vienne \\(N", "Ambassadeur à Vienne, \\(N" ),
      meta_dep=str_replace_all(meta_dep, "Ministre Turin", "Ministre à Turin" ),
      meta_dep=str_replace_all(meta_dep, "Copenhagne", "Copenhague"),
      meta_dep=str_replace_all(meta_dep, "À COPENHAGUE", "à Copenhague"),
      meta_dep=str_replace_all(meta_dep, "aux Agents de l Empereur", "aux Agents diplomatiques de l Empereur"),
      meta_dep=str_replace_all(meta_dep, "Ambassadeur à Londres \\(", "Ambassadeur à Londres, \\("),
      meta_dep=str_replace_all(meta_dep, "Ministre à Copenhague \\(", "Ministre à Copenhague, \\("),
      meta_dep=str_replace_all(meta_dep, "Baron de Malaret Ministre à Turin", "Baron de Malaret, Ministre à Turin"),
      meta_dep=str_replace_all(meta_dep, "Meroux de Valoix", "Méroux de Valois"),
      meta_dep=str_replace_all(meta_dep, "Meroux de Valois", "Méroux de Valois"),
      meta_dep=str_replace_all(meta_dep, "Les Délégués des Populations danoises du Sleswig", "Les Délégués des Populations danoises du Sleswig,, "),
      meta_dep=str_replace_all(meta_dep, "Le Procureur général à Colmar", "Le Procureur général à Colmar,, "),
      meta_dep=str_replace_all(meta_dep, "Ambassadeur Berlin", "Ambassadeur à Berlin"),
      meta_dep=str_replace_all(meta_dep, "Ambassadeur Londres", "Ambassadeur à Londres"),
      meta_dep=str_replace_all(meta_dep, "\\*Chargé", "Chargé"),
      meta_dep=str_replace_all(meta_dep, "Affaires à Berlin ", "Affaires à Berlin, "),
      meta_dep=str_replace_all(meta_dep, "Ministre 5 Dresde", "Ministre à Dresde"),
      meta_dep=str_replace_all(meta_dep, "de Lliuys", "de Lhuys"),
      meta_dep=str_replace_all(meta_dep, "baron", "Baron"),
      meta_dep=str_replace_all(meta_dep, "Argent", "Agent"),
      meta_dep=str_replace_all(meta_dep, "â Hanovre", "à Hanovre"),
      meta_dep=str_replace_all(meta_dep, "de \\(Gramont", "de Gramont"),
      meta_dep=str_replace_all(meta_dep, "Affaires à Berlin:", "Affaires à Berlin,"),
      meta_dep=str_replace_all(meta_dep, "à Francfort.", "à Francfort,"),
      meta_dep=str_replace_all(meta_dep, "affaires", "Affaires"),
      meta_dep=str_replace_all(meta_dep, "Munich:", "Munich,"),
      meta_dep=str_replace_all(meta_dep, "Luys", "Lhuys"),
      meta_dep=str_replace_all(meta_dep, "à\\.", "à"),
      meta_dep=str_replace_all(meta_dep, "duc", "Duc"),
      meta_dep=str_replace_all(meta_dep, "Bismarck Président", "Bismarck, Président"),
      meta_dep=str_replace_all(meta_dep, "Maréchal Bandon", "Maréchal Randon"),
      meta_dep=str_replace_all(meta_dep, "premier Aide", "Premier Aide"),
      meta_dep=str_replace_all(meta_dep, "Forth Bouen", "Forth Rouen"),
      meta_dep=str_replace_all(meta_dep, "Agriculture, du Commerce", "Agriculture du Commerce"),
      meta_dep=str_replace_all(meta_dep, "Guerre\\.", "Guerre"),
      meta_dep=str_replace_all(meta_dep, "de la Guerre \\(", "de la Guerre, \\("),
      meta_dep=str_replace_all(meta_dep, "Dieudé Defly\\.", "Dieudé Defly,"),
      meta_dep=str_replace_all(meta_dep, "Vicomte des\\.", "Vicomte des"),
      meta_dep=str_replace_all(meta_dep, "^yn de Lhuys", "Drouyn de Lhuys"),
      meta_dep=str_replace_all(meta_dep, "a Berlin", "à Berlin"),
      meta_dep=str_replace_all(meta_dep, "à \\.", "à"),
      meta_dep=str_replace_all(meta_dep, "à Vienne\\. Télégr", "à Vienne, Télégr"),
      meta_dep=str_replace_all(meta_dep, "a Vienne", "à Vienne"),
      meta_dep=str_replace_all(meta_dep, "Ambassadeur\\. Vienne", "Ambassadeur à Vienne"),
      meta_dep=str_replace_all(meta_dep, "Ambassadeur Vienne", "Ambassadeur à Vienne"),
      meta_dep=str_replace_all(meta_dep, "Gramont\\. Ambassadeur", "Gramont, Ambassadeur"),
      meta_dep=str_replace_all(meta_dep, "Cadore\\. Ministre", "Cadore, Ministre"),
      meta_dep=str_replace_all(meta_dep, "agent intérimaire", "Agent intérimaire"),
      meta_dep=str_replace_all(meta_dep, "TraDuction", "Traduction"),
      meta_dep=str_replace_all(meta_dep, "Dot zac", "Dotézac"),
      meta_dep=str_replace_all(meta_dep, "Étrangères.", "étrangères"),
      meta_dep=str_replace_all(meta_dep, "aide", "Aide"),
      meta_dep=str_replace_all(meta_dep, "Ambassadeurà", "Ambassadeur à"),
      meta_dep=str_replace_all(meta_dep, "II. de", "H. de"),
      meta_dep=str_replace_all(meta_dep, "Le B uf", "Le Boeuf"),
      meta_dep=str_replace_all(meta_dep, "Marquis e", "Marquis de"),
      meta_dep=str_replace_all(meta_dep, "deMetternich", "de Metternich"),
      meta_dep=str_replace_all(meta_dep, "Dieudé Delly", "Dieudé Defly"),
      meta_dep=str_replace_all(meta_dep, "Pietri", "Piétri"),
      meta_dep=str_replace_all(meta_dep, "G. Quaade", "G.J. Quaade"),
      meta_dep=str_replace_all(meta_dep, "J. de Quaade", "G.J. Quaade"),
      meta_dep=str_replace_all(meta_dep, "Le Comte de Bismarck", "M. de Bismarck"),
      meta_dep=str_replace_all(meta_dep, "au Comte de Bismarck", "à M. de Bismarck"),
      meta_dep=str_replace_all(meta_dep, "\\( \\) Saint Pétersbourg, 16\\/28 août 1866", "Inconnu de Saint Pétersbourg,,à Inconnu,,"),
      meta_dep=str_replace_all(meta_dep, "\\. \\(" , ", \\(" )
    )
  return(df_txt_sty_nbp_chr_dep_tdm_met1)
}
#################################################################



#################################################################
# fonction meta2_tt_titre
#
# cette fonction effectue des corrections 
# de manière à ce que les expéditeurs et les destinataires 
# aient un titre (une fonction) associé à leur nom
#################################################################

meta2_tt_titre= function(df_txt_sty_nbp_chr_dep_tdm_met1) {
  
  df_txt_sty_nbp_chr_dep_tdm_met2 <- df_txt_sty_nbp_chr_dep_tdm_met1 %>%
    mutate ( 
      # mise en forme de meta_dep de sorte que chaque personne, expediteur ou destinataire, ait un titre 
      meta_dep=str_replace_all(meta_dep, "Drouyn de Lhuys","Drouyn de Lhuys, MAEDF,"),
      meta_dep=str_replace_all(meta_dep, "Napoléon III","Napoléon III, EDF,"),
      meta_dep=str_replace_all(meta_dep, "Aide de Camp de l Empereur, Envoyé","Aide de Camp de l Empereur Envoyé"),
      meta_dep=str_replace_all(meta_dep, "Lord Russell to the Earl Cowley" , "Lord Russell, Principal Secrétaire d État de S. M. Britannique, à Lord Cowley, Ambassadeur à Paris" ),
      meta_dep=str_replace_all(meta_dep, "Lord Clarendon and Lord Cowley" , "Lord Clarendon, Secrétaire d État aux Affaires Etrangères de S. M. Britannique, à Lord Cowley, Ambassadeur à Paris" ),
      meta_dep=str_replace_all(meta_dep, "Le Comte Clarendon" , "Lord Clarendon" ),
      meta_dep=str_replace_all(meta_dep, "Clarendon, Secrétaire d État aux Affaires étrangères" , "Clarendon, Secrétaire d État aux Affaires Etrangères de S. M. Britannique" ),
      meta_dep=str_replace_all(meta_dep, "Lord Clarendon à Lord Cowley" , "Lord Clarendon, Secrétaire d État aux Affaires Etrangères de S. M. Britannique, à Lord Cowley, Ambassadeur à Paris" ),
      meta_dep=str_replace_all(meta_dep, "Victor Emmanuel II" , "Victor Emmanuel" ),
      meta_dep=str_replace_all(meta_dep, "Victor Emmanuel" , "Victor Emmanuel, Roi d'Italie," ),
      meta_dep=str_replace_all(meta_dep, "Guillaume Ier" , "Guillaume Ier, Roi de Prusse," ),
      meta_dep=str_replace_all(meta_dep, "Alexandre Beckers" , "Alexandre Beckers, ni titre ni fonction," ),
      meta_dep=str_replace_all(meta_dep, "Le Baron de Courcel" , "Le Baron de Courcel, Attaché à la Direction Politique," ),
      meta_dep=str_replace_all(meta_dep, "Louis II" , "Louis II, Roi de Bavière," ),
      meta_dep=str_replace_all(meta_dep, "Rouher, Ministre d État" , "Rouher, Ministre d État \\(France\\)" ),
      meta_dep=str_replace_all(meta_dep, "Charles XV" , "Charles XV, Roi de Suède et de Norvège" ),
      meta_dep=str_replace_all(meta_dep, "Le Prince Napoléon" , "Le Prince Napoléon, cousin de l Empereur," ),
      

      #corrections spécifiques aux dépeches envoyées à plusieurs agents diplomatiques
      meta_dep=str_replace_all(meta_dep, "aux Agents diplomatiques" , "aux ADE, Agents diplomatiques" ),
      meta_dep=str_replace_all(meta_dep, "aux Ambassadeurs" , "aux A, Ambassadeurs" ),


      #corrections spécifiques
      meta_dep=ifelse(num_tome==1 & num_dep==53, "Dotézac, Ministre à Copenhague, à Drouyn de Lhuys, MAEDF,, (Télégr.)", meta_dep),
      meta_dep=ifelse(num_tome==1 & num_dep==54, "Le Baron Forth Rouen, Ministre à Dresde, à Drouyn de Lhuys, MAEDF,, (N3.)", meta_dep)
    )
  return(df_txt_sty_nbp_chr_dep_tdm_met2)
}
#################################################################




#################################################################
# fonction meta3_maedf
#
# cette fonction prend en compte le fait 
# que les ministres des affaires étrangères 
# ont changé au cours de la période étudiée
# #################################################################

meta3_maedf= function(df_txt_sty_nbp_chr_dep_tdm2) {
  
  df_txt_sty_nbp_chr_dep_tdm_met3 <- df_txt_sty_nbp_chr_dep_tdm_met2 
  
  #remplacement de "Marquis de La Valette" par "Marquis de La Valette, MAEDF,"
  cond=(df_txt_sty_nbp_chr_dep_tdm_met3$num_tome==12 & df_txt_sty_nbp_chr_dep_tdm_met3$num_dep>=3386 & df_txt_sty_nbp_chr_dep_tdm_met3$num_dep<=3642) 
  df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep[cond]=str_replace_all(df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep, "Marquis de La Valette" , "Marquis de La Valette, MAEDF," )[cond]
  
  #remplacement de "Marquis de Moustier" par "Marquis de Moustier, Ambassadeur à Constantinople,"
  cond=(df_txt_sty_nbp_chr_dep_tdm_met3$num_tome==12 & df_txt_sty_nbp_chr_dep_tdm_met3$num_dep >=3577 & df_txt_sty_nbp_chr_dep_tdm_met3$num_dep<=3631) 
  df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep[cond]=str_replace_all(df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep, "Marquis de Moustier" , "Marquis de Moustier, Ambassadeur à Constantinople," )[cond]
  
  cond=(df_txt_sty_nbp_chr_dep_tdm_met3$num_tome==12 & df_txt_sty_nbp_chr_dep_tdm_met3$num_dep>=3645) 
  df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep[cond]=str_replace_all(df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep, "au Ministre des Affaires étrangères" , "au Marquis de Moustier, MAEDF," )[cond]
  
  cond=(df_txt_sty_nbp_chr_dep_tdm_met3$num_tome==12 & df_txt_sty_nbp_chr_dep_tdm_met3$num_dep==3646) 
  df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep[cond]=str_replace_all(df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep, "au Marquis de La Valette" , "au Marquis de Moustier, MAEDF," )[cond]
  
  #remplacement de "Marquis de Moustier" par "Marquis de Moustier, MAEDF,"
  cond=(df_txt_sty_nbp_chr_dep_tdm_met3$num_tome==12 & df_txt_sty_nbp_chr_dep_tdm_met3$num_dep>=3647) 
  df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep[cond]=str_replace_all(df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep, "Marquis de Moustier" , "Marquis de Moustier, MAEDF," )[cond]
  
  return(df_txt_sty_nbp_chr_dep_tdm_met3)
}
#################################################################


#################################################################
# fonction meta4_decoup_seg
#
# cette fonction découpe la variable meta_dep en 5 segments
# seg1 et seg2 contiennent le nom de l'expéditeur et son titre (ou fonction)
# seg3 et seg4 contiennent le nom du destinataire et son titre (ou fonction)
# seg5 contient la partie restante de la variable meta_dep
###################################################################

meta4_decoup_seg=function(df_txt_sty_nbp_chr_dep_tdm_met3) {
  #creation et ajout des cinq premiers segments de meta_dep ( separe par la premiere  virgule)
  seg <- as.data.frame(str_split_fixed(df_txt_sty_nbp_chr_dep_tdm_met3$meta_dep, ",",5), stringsAsFactors=FALSE)
  seg <- seg %>% select( seg1=V1, seg2=V2, seg3=V3, seg4=V4, seg5=V5)
  df_txt_sty_nbp_chr_dep_tdm_met4 <- cbind(df_txt_sty_nbp_chr_dep_tdm_met3,seg) 
  
  return(df_txt_sty_nbp_chr_dep_tdm_met4)
}
#################################################################


#################################################################
# fonction meta5_exped_dest
#
# cette fonction cree deux variables
# non_dep qui indique s'il s'agit d'un document autre qu'une depeche 
# circulaire qui indique s'il d'agit d'une circulaire
# puis elle traite seg1 et seg2 et crée les variables
# exped, titr_exped les noms et titre(fonction) de l'expéditeur
# dest, titr_dest les noms et titre(fonction) du destinataire
###################################################################


meta5_exped_dest=function(df_txt_sty_nbp_chr_dep_tdm_met4) {
  
  #traitement de seg1 : creation de 
  # non_dep qui renseigne s'il s'agit d'un document autre qu'une depeche 
  
  pattern_non_dep <-    START %R% or("Annexe","Mémoire","Note","Rapport","Projet","Convention","Telégramme Havas","Article","Memento","Propositions","Réponse","Instructions","Mémorandum")
  pattern_circulaire <- START %R% "Circulaire"

  df_txt_sty_nbp_chr_dep_tdm_met5 <- df_txt_sty_nbp_chr_dep_tdm_met4 %>%
    mutate(
      #reperage des documents qui ne sont pas des depeches
      non_dep=as.numeric(str_detect(seg1, pattern_non_dep)),
      #reperage de circulaire et modification de seg1
      circulaire=as.numeric(str_detect(seg1, pattern_circulaire)),
      seg1=str_replace(seg1, "Circulaire de Drouyn", "Drouyn"),
      seg1=str_replace(seg1, "Circulaire du", "Le"),

      #expediteur destinataire (et titre)
      seg12=str_c(seg1,seg2),
      exped=ifelse(non_dep,NA,seg1),
      titr_exped=ifelse(non_dep,NA,seg2),
      exped_t=str_c(exped,titr_exped),

      seg34=str_c(seg3,seg4),
      dest=ifelse(non_dep,NA,seg3),
      titr_dest=ifelse(non_dep,NA,seg4),
      dest_t=str_c(dest,titr_dest),

      dest=str_replace_all(dest,"à ",""),
      dest=str_replace_all(dest,"au ","Le ")
    )
  return(df_txt_sty_nbp_chr_dep_tdm_met5)
}
#################################################################



#################################################################
# fonction meta6_dep_dip_fr
#
# cette fonction cree à l'aide d'espressions régulières  la variable 
# dep_dip_fr qui indique s'il s'agit d'une depeche diplomatique francaise
###################################################################

meta6_dep_dip_fr=function(df_txt_sty_nbp_chr_dep_tdm_met5) {
  
  # definition des pattern permettant de reperer   
  pattern1_ADE <- or("Agent consulaire","Ambassadeur",
                     "Chargé d Affaires","Consul général","Ministre",
                     "Secrétaire d Ambassade", "Agent intérimaire",
                     "Consul de France", "Secrétaire de Légation",
                     "Vice Consul","Consul") %R% 
    " à " %R%  negated_char_class("Paris")
  pattern2_ADE <- "MAEDF"
  pattern3_ADE <- "aux ADE"

  df_txt_sty_nbp_chr_dep_tdm_met6 <- df_txt_sty_nbp_chr_dep_tdm_met5 %>%
    mutate(
      #dépeche d'un agent diplomatique francais vers le Ministre des Affaires etrangères
      cas1=str_detect(titr_exped,pattern1_ADE) &
        str_detect(titr_dest,pattern2_ADE),
      
      #dépeche du Ministre des Affaires etrangère vers un ou plusieurs agents diplomatiques francais
       cas2=str_detect(titr_exped,pattern2_ADE) &
        str_detect(titr_dest,pattern1_ADE),
      
       cas3=str_detect(titr_exped,pattern2_ADE) &
        str_detect(dest,pattern3_ADE),
      
      #dépeche diplomatique francaise
      dep_dip_fr=as.numeric((cas1|cas2|cas3))
      
    ) %>%
     select(-seg1,-seg2,-seg3,-seg4,-seg12,-seg34,-cas1,-cas2,-cas3)

  return(df_txt_sty_nbp_chr_dep_tdm_met6)
}       
#################################################################



#################################################################
# fonction meta7_tt_seg5
#
# cette fonction cree, à l'aide d'espressions régulières, les variables 
# teleg, qui indique si la depeche est un telegramme
# particuliere, qui indique s'il s'agit d'une dépeche particulière
# confidentielle, qui indique s'il s agit d'une dépêche confidentielle
# negosec, qui indique s'il s'agit d'une dépêche 
# faisant partie des négociations secrètes
###################################################################

meta7_tt_seg5=function(df_txt_sty_nbp_chr_dep_tdm_met6) {

    pattern2_telegramme    =or("Télégr\\.","Télegr\\.","Telégr\\.","Télég\\.")
    pattern2_particuliere  ="Particulière" 
    pattern2_confidentielle=or("Confidentielle","confidentielle") 
    pattern2_negosec       ="Négociation secrète"
    
  df_txt_sty_nbp_chr_dep_tdm_met7 <- df_txt_sty_nbp_chr_dep_tdm_met6 %>%
  mutate(
    teleg         =as.numeric(str_detect(seg5,pattern2_telegramme)),
    particuliere  =as.numeric(str_detect(seg5,pattern2_particuliere)),
    confidentielle=as.numeric(str_detect(seg5,pattern2_confidentielle)),
    negosec       =as.numeric(str_detect(seg5,pattern2_negosec)),

   #modification manuelle pour certaines depeches specifiques
    teleg=ifelse(num_dep==2551,1,teleg)
  ) %>%
    select(-seg5)
  
  return(df_txt_sty_nbp_chr_dep_tdm_met7)
}    
    



