



##################################################################################
# construction de mots_maj
# mots contenus dans les textes du corpus commencant par une majuscule
# et ne faisant pas partie des stopwords

stop = str_to_title(stopwords(kind = "fr"))
mots <- row.names(df_tdm_en)
depeches <-names(df_tdm_en)

df_mots_maj <- as.data.frame(mots) %>%
  mutate(
    #creation de la variable maj qui indique si le mot commence par une majuscule
    maj = str_detect(mots, regex("^[A-Z]")),
    #creation de la variable stop_mots qui indique si le mot est un stop word
    stop_mots = mots %in% stop
  ) %>%
  filter(maj==TRUE & stop_mots == FALSE) %>%
  select(mots_maj=mots)%>%
  mutate(mots_maj = str_to_title(mots_maj, locale="fr"))

#les mots contenus dans les textes du corpus commencant par une majuscule
# et ne faisant pas partie des stopwords

mots_maj <- as.character(df_mots_maj$mots_maj)

