# ce script étudie plusieurs valeurs pour le nombre d'erreurs 
# pour le matching approximatif 

setwd("D:/memoire m2_LNakache/reseau benedetti-gramont/a_exporter")




########################################################################
# etude du nombre d erreurs pour apparier les mots du corpus 
# commencant par une majuscule et ne faisant pas partie des stopwords
# avec le vecteur des noms issu des notices vec_nom_tot_nom

vec_nom_tot_nom <- df_vect_nom_tot_nom$nom

invlistindex_id_D0= sapply(mots_maj, amatch, vec_nom_tot_nom, maxDist=0.05, method="lv")
invlistindex_id_D1= sapply(mots_maj, amatch, vec_nom_tot_nom, maxDist=1, method="lv")
invlistindex_id_D2= sapply(mots_maj, amatch, vec_nom_tot_nom, maxDist=2, method="lv")
invlistindex_id_D3= sapply(mots_maj, amatch, vec_nom_tot_nom, maxDist=3, method="lv")


df_invctrl <- as.data.frame(cbind(mots_maj ,vec_nom_tot_nom[invlistindex_id_D3],vec_nom_tot_nom[invlistindex_id_D2],vec_nom_tot_nom[invlistindex_id_D1],vec_nom_tot_nom[invlistindex_id_D0]))
names(df_invctrl)<- c("mots_maj","lv_3","lv_2","lv_1","lv_05")

#fin de l etude sur le nombre d erreurs
#########################################################################

#on edite quelques lignes du tableau 91 a 112
df_invctrl_91_112 <- df_invctrl %>% slice(91:112)
write.table(df_invctrl_91_112,"df_invctrl_91_112.csv",quote=FALSE,sep=",")
