# ce script cree un dataframe contenant une observation par depeche
# ainsi que ses metadonnees


load("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a9.RData")


# dataframe comprenant une observation par depeche 
# et calcul du nombre de mots par depeche
df_depdipfra<- df_txt_sty_nbp_chr_dep_tdm_met_tit %>%
  filter(flag_cor_dep==1 ) %>%
  group_by(num_dep) %>%
  summarise( text=paste0(texte,collapse="\n\n") ) %>%
  ungroup() %>%
  # calcul du mombre de mots
  mutate ( nb_mots=sapply(strsplit(text, " "), length ))

# dataframe des metadonnees 
df_depdipfrb <- df_txt_sty_nbp_chr_dep_tdm_met_tit %>%
  filter(num_new_parad==1  ) %>%
  select(num_dep,date,date_c,exped,titr_exped,dest,titr_dest,
         circulaire,teleg,particuliere,confidentielle,negosec,
         type, num_tome,num_page) %>%
  arrange(num_dep)

#merge des deux dataframes    
df_depdipfr <- merge(df_depdipfra,df_depdipfrb,by="num_dep")


#enregistrement de l'environnement
save.image("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a10.RData")


# nettoyage de l environnement 
# et creation d'un environnement ne contenant que le dataframe df_depdipfr
load("D:/memoire m2_LNakache/constitution du corpus/environnements/Rscript1a10.RData")
save.image("D:/memoire m2_LNakache/constitution du corpus/environnements/Rdepdipfr.RData")


