load("D:/memoire m2_LNakache/constitution du corpus/environnements/Rdepdipfr.RData")

setwd("D:/memoire m2_LNakache/iramuteq/corpus txm/diplosadowa")



# chargement des packages
library(dplyr)
library(stringr)
library (rebus)
library (readr)
library(ggraph)
library(igraph)
library(stringdist)
library(tidyverse) 
library(dplyr)
library(tm)
library(rebus)
library(tibble)
library(stringr)
library(lubridate)



##############################################################################
#creation des fichiers TXT 
# selection des lettres écrites par les agents diplomatiques
# et remplacement des apostrophes par des espaces 
df_iramuteq <- df_depdipfr %>%
  filter(type=="adep" & teleg==0) %>%
  mutate(
    text=str_replace_all(text, "\\'", " ")
    ) %>%
  select(num_dep, text, exped, num_tome, num_page)

text= df_iramuteq$text

#ecriture des textes 
for (i in 1:9) {
  name = paste("00",i, ".txt", sep="")
  write.table(text[i], file = name, col.names = F, fileEncoding = "UTF-8")  
}

for (i in 10:99) {
  name = paste("0",i, ".txt", sep="")
  write.table(text[i], file = name, col.names = F, fileEncoding = "UTF-8")  
}

for (i in 100:803) {
  name = paste(i, ".txt", sep="")
  write.table(text[i], file = name, col.names = F, fileEncoding = "UTF-8")  
}
##############################################################################


##############################################################################
# creation des metadonnees


##############################################################################
#creation de l'identifiant 
vec_hex00 = ""
vec_hex0  = ""
vec_hex   = ""

for (i in 1:9){
  vec_hex00[i]= paste0("00", i, sep="")
}

for (i in 1:99){
  vec_hex0[i]= paste0("0", i, sep="")
}
vec_hex0= vec_hex0[10:length(vec_hex0)]

for (i in 99:802){
  vec_hex[i]= i+1
}
vec_hex = vec_hex[99:length(vec_hex)]

vec_id = c(vec_hex00, vec_hex0, vec_hex)
##############################################################################



df_metadata = df_depdipfr %>%
  filter(type=="adep" & teleg==0) %>%
  mutate(
    id =  as.character(vec_id),
    num_dep = as.character(num_dep),
    num_page = as.character(num_page),
    num_tome = as.character(num_tome),
    particuliere = as.character(particuliere),
    confidentielle = as.character(confidentielle),
    negosec = as.character(negosec)
  ) %>%
  select(id,num_dep, exped,num_page, num_tome, particuliere, confidentielle, negosec)



setwd("D:/memoire m2_LNakache/iramuteq/corpus txm")

write.table(df_metadata, file="metadata.csv",col.names=T, row.names=F, sep=",", fileEncoding = "UTF-8")
